package com.yc.ship.module.product.service.productSpu;

import cn.hutool.core.lang.tree.TreeNode;
import com.yc.ship.framework.common.pojo.CommonResult;
import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.product.api.dto.ProductSpuRespDTO;
import com.yc.ship.module.product.controller.admin.productSpu.spuVO.*;
import com.yc.ship.module.product.dal.dataobject.productSku.ProductSkuDO;
import com.yc.ship.module.product.dal.dataobject.productSpu.ProductSpuDO;
import com.yc.ship.module.resource.controller.admin.resource.vo.ReducedResourceRespVO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;
import java.util.Map;


/**
 * 产品基础信息 Service 接口
 *
 * @author 管理员
 */
public interface ProductSpuService {
    /**
     * 扣减资源库存锁
     */
    String REDUCE_RESOURCE_LOCK = "reduce:resource:lock:%d";
    /**
     * 扣减基础产品库存锁
     */
    String REDUCE_BASE_PRODUCT_LOCK = "reduce:base:product:lock:%d";
    /**
     * 扣减产品库存锁
     */
    String REDUCE_PRODUCT_LOCK = "reduce:product:lock:%d";

    /**
     * 创建产品基础信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProductSpu(@Valid ProductSpuSaveReqVO createReqVO);

    /**
     * 更新产品基础信息
     *
     * @param updateReqVO 更新信息
     */
    void updateProductSpu(@Valid ProductSpuSaveReqVO updateReqVO);

    /**
     * 删除产品基础信息
     *
     * @param id 编号
     */
    void deleteProductSpu(Long id);

    /**
     * 获得产品基础信息
     *
     * @param id 编号
     * @return 产品基础信息
     */
    ProductSpuDO getProductSpu(Long id);

    /**
     * 获得产品信息
     *
     * @param id 产品Id
     * @return ProductSpuRespVO
     */
    ProductSpuRespVO getProductSpuResp(Long id, String date, Long planId);

    ProductSpuRespVO getProductSpuResp(Long id,String date,Long planId,boolean isEdit);
    /**
     * 获得产品基础信息分页
     *
     * @param pageReqVO 分页查询
     * @return 产品基础信息分页
     */
    PageResult<ProductSpuRespVO> getProductSpuPage(ProductSpuPageReqVO pageReqVO);

    List<ProductSpuSimpleRespVO> getProductSpuListByCategory(Long categoryId);

    /**
     * 获得产品基础信息分页
     *
     * @param pageReqVO 分页查询
     * @return 产品基础信息分页
     */
    PageResult<ProductSpuRespVO> getAppletProductPage(ProductSpuPageReqVO pageReqVO);

    CommonResult<List<ProductSpuRespDTO>> getProductListByTenantId(Long tenantId);

    List<ProductSpuRespDTO> listAllSpu();

    /**
     * 获得产品列表
     *
     * @param ids 产品编号数组
     * @return 产品列表
     */
    List<ProductSpuDO> getProductList(Collection<Long> ids);

    /**
     * 根据租户查询产品
     *
     * @param pageReqVO 参数
     * @return 产品规格列表
     */
    PageResult<ProductSpuRespVO> selectSpuListByTenantId(ProductSpuPageReqVO pageReqVO);

    /**
     * 组合产品扣减库存
     */
    List<ReducedResourceRespVO> reduceProductStock(List<ProductReduceStockReqVO> list);

    void updateStatus(Long id, Integer status);

    List<ProductSpuDO> getProductSpuListByStatus(Long categoryId, Integer channelId, Integer status);

    List<Map<String,Object>> getProductSpuList(Collection<Long> categoryIds);

    List<TreeNode> getCategoryAndSpuList();

    List<TreeNode> getDistributorProductSpuList();

    List<ProductSpuSimpleVO> selectSimpleList(ProductSpuPageReqVO pageReqVO);
    List<ProductSpuSimpleVO> listByShipId(Long shipId);

    List<ProductSkuDO> getProductSkuList(List<Long> ids);
}
